import { inPolygon, inPolyline } from './utils/math';
export function isPointInPath(displayObject, position) {
  var _a = displayObject.parsedStyle,
      stroke = _a.stroke,
      fill = _a.fill,
      _b = _a.lineWidth,
      lineWidth = _b === void 0 ? 0 : _b,
      points = _a.points,
      _c = _a.defX,
      x = _c === void 0 ? 0 : _c,
      _d = _a.defY,
      y = _d === void 0 ? 0 : _d,
      clipPathTargets = _a.clipPathTargets;
  var isClipPath = !!(clipPathTargets === null || clipPathTargets === void 0 ? void 0 : clipPathTargets.length);
  var isHit = false;

  if (stroke || isClipPath) {
    isHit = inPolyline(points.points, lineWidth, position.x + x, position.y + y, true);
  }

  if (!isHit && (fill || isClipPath)) {
    isHit = inPolygon(points.points, position.x + x, position.y + y);
  }

  return isHit;
}