import { inPolyline } from './utils/math';
export function isPointInPath(displayObject, position) {
  var _a = displayObject.parsedStyle,
      stroke = _a.stroke,
      _b = _a.lineWidth,
      lineWidth = _b === void 0 ? 0 : _b,
      points = _a.points,
      _c = _a.defX,
      x = _c === void 0 ? 0 : _c,
      _d = _a.defY,
      y = _d === void 0 ? 0 : _d,
      clipPathTargets = _a.clipPathTargets;
  var isClipPath = !!(clipPathTargets === null || clipPathTargets === void 0 ? void 0 : clipPathTargets.length);

  if (!stroke && !isClipPath || !lineWidth) {
    return false;
  }

  return inPolyline(points.points, lineWidth, position.x + x, position.y + y, false);
}