"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isPointInPath = isPointInPath;

var _math = require("./utils/math");

function isPointInPath(displayObject, position) {
  var _a = displayObject.parsedStyle,
      _b = _a.r,
      r = _b === void 0 ? 0 : _b,
      fill = _a.fill,
      stroke = _a.stroke,
      _c = _a.lineWidth,
      lineWidth = _c === void 0 ? 0 : _c,
      clipPathTargets = _a.clipPathTargets;
  var halfLineWidth = lineWidth / 2;
  var absDistance = (0, _math.distance)(r, r, position.x, position.y);
  var isClipPath = !!(clipPathTargets === null || clipPathTargets === void 0 ? void 0 : clipPathTargets.length); // 直接用距离，如果同时存在边和填充时，可以减少两次计算

  if (fill && stroke || isClipPath) {
    return absDistance <= r + halfLineWidth;
  }

  if (fill) {
    return absDistance <= r;
  }

  if (stroke) {
    return absDistance >= r - halfLineWidth && absDistance <= r + halfLineWidth;
  }

  return false;
}