"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Plugin = void 0;

var _g = require("@antv/g");

var _inversify = require("inversify");

var _CanvasPickerPlugin = require("./CanvasPickerPlugin");

var _Circle = require("./Circle");

var _Ellipse = require("./Ellipse");

var _Line = require("./Line");

var _Polyline = require("./Polyline");

var _Path = require("./Path");

var _Rect = require("./Rect");

var _Polygon = require("./Polygon");

var containerModule = new _inversify.ContainerModule(function (bind, unbind, isBound, rebind) {
  bind(_CanvasPickerPlugin.PointInPathPickerFactory).toFactory(function (ctx) {
    return function (tagName) {
      if (tagName === _g.SHAPE.Circle) {
        return _Circle.isPointInPath;
      } else if (tagName === _g.SHAPE.Ellipse) {
        return _Ellipse.isPointInPath;
      } else if (tagName === _g.SHAPE.Rect) {
        return _Rect.isPointInPath;
      } else if (tagName === _g.SHAPE.Line) {
        return _Line.isPointInPath;
      } else if (tagName === _g.SHAPE.Polyline) {
        return _Polyline.isPointInPath;
      } else if (tagName === _g.SHAPE.Polygon) {
        return _Polygon.isPointInPath;
      } else if (tagName === _g.SHAPE.Path) {
        return _Path.isPointInPath;
      } else if (tagName === _g.SHAPE.Image || tagName === _g.SHAPE.Text // tagName === SHAPE.Group
      ) {
        return function () {
          return true;
        };
      }

      return null;
    };
  });
  bind(_CanvasPickerPlugin.CanvasPickerPlugin).toSelf().inSingletonScope();
  bind(_g.RenderingPluginContribution).toService(_CanvasPickerPlugin.CanvasPickerPlugin);
});

var Plugin = function () {
  function Plugin() {}

  Plugin.prototype.init = function (container) {
    container.load(containerModule);
  };

  Plugin.prototype.destroy = function (container) {
    container.unload(containerModule);
  };

  return Plugin;
}();

exports.Plugin = Plugin;